.Dd February 25, 1996
.Dt MIDIGREP N
.Os
.Sh NAME
.Nm midigrep
.Nd "tclmidi command to find events matching a given pattern in a MIDI track"
.Sh SYNOPSIS
.Nm
.Ar MidiID
.Ar track
.Ar event
.Op event ...
.Sh DESCRIPTION
.Nm
is a
.Xr tclmidi 1
command that
will find all events in a specified track
that match the pattern events in the command argumets.
This first argument is the descriptor for
the \%MIDI song.
This descriptor should be one returned by
.Xr midimake n
or
.Xr midiread n .
The second argument specifies the track to
index.
The third and remaining arguments are events
that you wish to locate.
The syntax of these events is the same as that
specified in
.Xr midievent n ,
except that any field besides the event type
field may be replaced by the * character.
The * character then acts as a wildcard and will
match any value normally found for that parameter
of the specified event type.
Any number of fields for an event can be wildcarded.
.Pp
For example,
.Em midigrep song0 1 {* Note 1 42 * *}
will find all
.Em Note
events in
.Em song0
track
.Em 1
that are for channel 1, pitch 42,
regardless of the note velocity, duration or the time the
Note event occurs.
.Sh RETURN VALUES
.Nm
returns a list off all the events that match the given
event patterns.
.Sh SEE ALSO
.Xr tclmidi 1 ,
.Xr midiread n ,
.Xr midimake n ,
.Xr midievents n
.Sh AUTHOR
Mike Durian - durian@boogie.com
